
TYPO3.Flow - Feature # 43966

Work Package # 45088 (Resolved): Improved REST support

Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: MVC - Routing
Created: 2012-12-13 Assigned To: Bastian Waidelich
Updated: 2013-09-23 Due date:
PHP Version:
Has patch: No
Complexity:
Subject: Allow all routes to include sub routes
Description

Sub routes are currently only resolved in the global Configuration/Routes.yaml file.
It would be nice if sub routes could include sub routes them selves.
This also requires us to be able to specify a path.

The syntax could be similar to:

 1-
 2  # loads sub routes from My.Package/Configuration/Routes.yaml
 3  uriPattern: '<SomeSubroutes>'
 4  subRoutes:
 5    SomeSubroutes:
 6      package: My.Package
 7-
 8  # loads sub routes from Other.Package/Configuration/RestRoutes.yaml
 9  uriPattern: '<SomeSubroutes>'
10  subRoutes:
11    SomeSubroutes:
12      package: Other.Package
13      filename: RestRoutes.yaml

Related issues:
related to TYPO3.Flow - Bug # 47255: Cache is not flushed for changes in sub ... Resolved 2013-04-15

Associated revisions
Revision 15788c42 - 2013-02-26 16:53 - Bastian Waidelich

[FEATURE] Routing: Nested SubRoutes

With this change it's possible to load SubRoutes from other SubRoutes.
The syntax is the same as before with two additions:

1. You can specify a ``suffix`` in order to load a SubRoute from
    a different file than the default ``Routes.yaml``
2. You can set ``variables`` that will be replaced in the merged SubRoutes

Usage:

2015-08-04 1/4



-
  name: 'Product'
  uriPattern: 'products/<EntitySubroutes>'
  defaults:
    '@package':    'My.Package'
    '@controller': 'Product'
  subRoutes:
    'EntitySubroutes':
      package: 'MyPackage.RestTest'       # load SubRoutes from My.Package/Configuration/Routes.Entity.yaml
      suffix:  'Entity'       # replace placeholder "<entityName>" with "product":
      variables:
        'entityName': 'product'

Change-Id: I9bc3519b359b32ec5b89edd47d3e3bce6f986749
Resolves: #43966
Releases: master

Revision 7ca72da7 - 2013-05-29 16:36 - Bastian Waidelich

[BUGFIX] Cache is not flushed for changes in sub routes

The CacheManager automatically flushes routing caches in
Development context if a Routes.yaml file was changed.
This extends the behavior to flush caches even if a custom
sub route (Routes.xyz.yaml) was modified.

Change-Id: If77c9c5ec2880e89e2915f5795c98a36599815fb
Fixes: #47255
Related: #43966
Releases: master, 2.0

Revision dc6ec95e - 2013-06-05 13:00 - Bastian Waidelich

[FEATURE] Routing: Nested SubRoutes

With this change it's possible to load SubRoutes from other SubRoutes.
The syntax is the same as before with two additions:

1. You can specify a ``suffix`` in order to load a SubRoute from
    a different file than the default ``Routes.yaml``
2. You can set ``variables`` that will be replaced in the merged SubRoutes

Usage:

-
  name: 'Product'
  uriPattern: 'products/<EntitySubroutes>'
  defaults:
    '@package':    'My.Package'
    '@controller': 'Product'
  subRoutes:
    'EntitySubroutes':
      package: 'MyPackage.RestTest'       # load SubRoutes from My.Package/Configuration/Routes.Entity.yaml
      suffix:  'Entity'       # replace placeholder "<entityName>" with "product":
      variables:
        'entityName': 'product'

Change-Id: I9bc3519b359b32ec5b89edd47d3e3bce6f986749
Resolves: #43966
Releases: master

Revision 2382549f - 2013-06-05 13:01 - Bastian Waidelich

[BUGFIX] Cache is not flushed for changes in sub routes

The CacheManager automatically flushes routing caches in
Development context if a Routes.yaml file was changed.
This extends the behavior to flush caches even if a custom
sub route (Routes.xyz.yaml) was modified.

Change-Id: If77c9c5ec2880e89e2915f5795c98a36599815fb
Fixes: #47255
Related: #43966
Releases: master, 2.0

History
#1 - 2012-12-14 14:27 - Bastian Waidelich

I implemented a first draft supporting following syntax:

1-
2  # loads sub routes from Other.Package/Configuration/Routes.Foo.yaml
3  uriPattern: '<SomeSubroutes>'
4  subRoutes:
5    SomeSubroutes:
6      package: Other.Package
7      suffix: Foo

#2 - 2013-02-22 10:37 - Bastian Waidelich
- Parent task set to #45088

#3 - 2013-02-26 13:21 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18478
#4 - 2013-02-26 16:53 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18478

#5 - 2013-02-27 08:36 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:15788c42ed75d02ed48f277a58fb8f4748ff3677.

#6 - 2013-03-28 16:21 - Aske Ertmann
- Parent task deleted (#45088)

#7 - 2013-03-28 16:22 - Aske Ertmann
- Parent task set to #45088

#8 - 2013-05-15 12:23 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/20784

#9 - 2013-05-21 13:28 - Robert Lemke
- Target version deleted (2.1)

#10 - 2013-06-05 13:02 - Gerrit Code Review

Patch set 2 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/20784

#11 - 2013-09-23 14:22 - Bastian Waidelich
- Status changed from Under Review to Resolved
